"""
Partially generated by datamodel-codegen:
   filename:  https://gitlab.com/kicad/code/kicad/-/raw/master/resources/schemas/drc.v1.json
   timestamp: 2024-01-03T16:11:36+00:00
"""

# pylint: disable=duplicate-code

from __future__ import annotations

from datetime import datetime
from typing import Annotated, List

from pydantic import BaseModel, ConfigDict, Field, constr

from edea.kicad.cli_types import CoordinateUnits, Violation


class KicadDRCReport(BaseModel):
    model_config = ConfigDict(extra="forbid", populate_by_name=True)
    field_schema: str | None = Field(
        alias="$schema", description="JSON schema reference"
    )
    source: str = Field(..., description="Source file path")
    date: datetime = Field(..., description="Time at generation of report")
    kicad_version: Annotated[
        str, constr(pattern=r"^\d{1,2}(\.\d{1,2}(\.\d{1,2})?)?$")
    ] = Field(..., description="KiCad version used to generate the report")
    violations: List[Violation]
    unconnected_items: List[Violation]
    schematic_parity: List[Violation]
    coordinate_units: CoordinateUnits = Field(
        ..., description="Units that all coordinates in this report are encoded in"
    )
